'   Jared's Subway Adventure Demo
'    By: Blurred Visions


DECLARE SUB JaredInitVariables ()
DECLARE SUB JaredGetGraphics ()
DECLARE SUB JaredIntro ()
DECLARE SUB JaredDrawLevel ()
DECLARE SUB JaredMainLoop ()
DECLARE SUB JaredCheckDeath ()

SCREEN 13

CONST NumberOfLevels = 2
CONST NumberOfGuys = 2
CONST GroundLevel = 81
CONST NumberOfTiles = 8
CONST LengthOfTile = 10
CONST HeightOfTile = 10
CONST LengthOfMap = 28
CONST HeightOfMap = 10
CONST SizeOfImage = LengthOfTile * HeightOfTile
CONST OneStep = LengthOfTile

DIM SHARED Temp(SizeOfImage * 2)
DIM SHARED TheSub(SizeOfImage)
DIM SHARED Graphics(SizeOfImage * NumberOfTiles)
DIM SHARED Associate(NumberOfTiles)
DIM SHARED AssociateYou(NumberOfGuys)
DIM SHARED YourGuy((SizeOfImage * 2) * NumberOfGuys)
DIM SHARED YourGuyMask((SizeOfImage * 2) * NumberOfGuys)
DIM SHARED AreaMap(LengthOfMap, HeightOfMap, NumberOfLevels)
DIM SHARED X, Y, CurrentDirection, AssociateX, AssociateY, InAir, SubX, SubY, GotSub, CurrentLevel, Falling, Count
DIM SHARED Grass, Water, Nothing, Ladder, WildBlock, GrassWithSub, GrassReturn, UnderGround

UnderGround = 3
Grass = 2
Water = 1
Ladder = 6
Nothing = 7
WildBlock = 8
GrassWithSub = 4
GrassReturn = 5

CurrentLevel = 1

CALL JaredInitVariables
CALL JaredGetGraphics
CALL JaredIntro
CALL JaredDrawLevel

DO
CALL JaredMainLoop
JaredCheckDeath
LOOP



DATA 1, 0, 1, 0, 1, 0, 1, 0, 0, 0
DATA 0, 1, 1, 1, 0, 1, 1, 1, 0, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
DATA 2, 2, 0, 2, 0, 2, 2, 2, 0, 2
DATA 2, 2, 2, 2, 2, 2, 2, 2, 6, 2
DATA 2, 2, 2, 8, 2, 8, 6, 8, 2, 8
DATA 8, 2, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 2, 2, 0, 2, 0, 2, 2, 2, 0, 2
DATA 2, 2, 2, 2, 2, 2, 2, 2, 6, 2
DATA 2, 2, 2, 8, 2, 8, 6, 8, 2, 8
DATA 8, 2, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 2, 2, 0, 2, 0, 2, 2, 2, 0, 2
DATA 2, 2, 2, 2, 2, 2, 2, 2, 6, 2
DATA 2, 2, 2, 8, 2, 8, 6, 8, 2, 8
DATA 8, 2, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 6, 8, 6, 8, 6, 8, 6, 8, 6, 8
DATA 8, 6, 8, 6, 8, 6, 8, 6, 8, 6
DATA 12, 6, 0, 0, 0, 0, 0, 0, 8, 6
DATA 8, 6, 0, 0, 0, 0, 0, 0,12, 6
DATA 12, 6, 0, 0, 0, 0, 0, 0, 8, 6
DATA 8, 6, 0, 0, 0, 0, 0, 0,12, 6
DATA 12, 6,12, 8,12, 8,12, 8, 6, 6
DATA 8, 6, 6, 6, 6, 6, 6, 6, 6, 6
DATA 12, 6, 0, 0, 0, 0, 0, 0, 8, 6
DATA 8, 6, 0, 0, 0, 0, 0, 0,12, 6
DATA 12, 6, 0, 0, 0, 0, 0, 0, 8, 6
DATA 8, 6, 0, 0, 0, 0, 0, 0,12, 6
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 1,12,12, 7, 0, 1, 1,12, 0
DATA 0,12,12, 7, 7, 1, 1,12,12, 0
DATA 0,12, 7, 7, 1, 1,12,12, 1, 0
DATA 0, 7, 7, 1, 1,12,12, 1, 1, 0
DATA 0, 7, 1, 1,12,12, 1, 1, 7, 0
DATA 0, 1, 1,12,12, 1, 1, 7, 7, 0
DATA 0, 1,12,12, 1, 1, 7, 7,12, 0
DATA 0,12,12, 1, 1, 7, 7,12,12, 0
DATA 0,12, 1, 1, 7, 7,12,12, 1, 0
DATA 0, 0, 0,15,15,15, 0, 0, 0, 0
DATA 0, 0,15,15,12,12,15, 0, 0, 0
DATA 0,15,15,12, 1,12, 0, 0, 0, 0
DATA 0,15,15,12, 1,12, 0, 0, 0, 0
DATA 0,15,15,12,12,12, 0, 0, 0, 0
DATA 0,15,12,12,12, 0, 0, 0, 0, 0
DATA 0, 0, 9, 9, 9, 0, 0, 0, 0, 0
DATA 0, 9, 9, 9, 9, 9, 0, 0, 0, 0
DATA 0, 9, 1, 1, 9, 9, 0, 0, 0, 0
DATA 0, 9, 1, 1, 9, 9, 0, 0, 0, 0
DATA 0, 9, 1, 1, 9, 9, 0, 0, 0, 0
DATA 0, 9, 1, 1, 9, 9, 0, 0, 0, 0
DATA 0, 9, 1, 1, 9, 9, 0, 0, 0, 0
DATA 0, 8, 1, 1, 9, 8, 0, 0, 0, 0
DATA 0, 8, 1, 1, 8, 8, 0, 0, 0, 0
DATA 0, 8,12,12, 8, 8, 0, 0, 0, 0
DATA 0, 8, 8,12, 8, 8, 0, 0, 0, 0
DATA 0, 8, 8, 8, 8, 8, 0, 0, 0, 0
DATA 0, 8, 8, 8, 7, 7, 0, 0, 0, 0
DATA 0, 8,15,15,15,15,15, 0, 0, 0
DATA 0, 0, 0, 0,15,15,15, 0, 0, 0
DATA 0, 0, 0,15,12,12,15,15, 0, 0
DATA 0, 0, 0, 0,12, 1,12,15,15, 0
DATA 0, 0, 0, 0,12, 1,12,15,15, 0
DATA 0, 0, 0, 0,12,12,12,15,15, 0
DATA 0, 0, 0, 0, 0,12,12,12,15, 0
DATA 0, 0, 0, 0, 0, 9, 9, 9, 0, 0
DATA 0, 0, 0, 0, 9, 9, 9, 9, 9, 0
DATA 0, 0, 0, 0, 9, 9, 1, 1, 9, 0
DATA 0, 0, 0, 0, 9, 9, 1, 1, 9, 0
DATA 0, 0, 0, 0, 9, 9, 1, 1, 9, 0
DATA 0, 0, 0, 0, 9, 9, 1, 1, 9, 0
DATA 0, 0, 0, 0, 9, 9, 1, 1, 9, 0
DATA 0, 0, 0, 0, 8, 9, 1, 1, 8, 0
DATA 0, 0, 0, 0, 8, 8, 1, 1, 8, 0
DATA 0, 0, 0, 0, 8, 8,12,12, 8, 0
DATA 0, 0, 0, 0, 8, 8,12, 8, 8, 0
DATA 0, 0, 0, 0, 8, 8, 8, 8, 8, 0
DATA 0, 0, 0, 0, 7, 7, 8, 8, 8, 0
DATA 0, 0, 0,15,15,15,15,15, 8, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
DATA 0, 0, 6, 6, 6, 6, 6, 6, 6, 0
DATA 0, 2, 8, 2, 8, 2, 8, 2, 8, 2
DATA 0, 0, 6, 6, 6, 6, 6, 6, 6, 0
DATA 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,6,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,6,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,6,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,6,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,6,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7
DATA 5,2,2,2,2,2,2,2,1,1,1,2,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,4
DATA 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
DATA 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7
DATA 7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7
DATA 7,7,7,6,7,7,7,7,7,7,7,6,7,7,7,7,7,7,7,7,7,7,6,7,7,7,7,7
DATA 7,7,2,2,1,1,1,2,1,1,1,2,1,1,1,2,7,7,7,7,7,7,6,7,7,7,7,7
DATA 5,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,1,2,1,2,1,1,2,2,4
DATA 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3

SUB JaredCheckDeath

IF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = Water THEN
DO: LOOP WHILE INKEY$ <> ""
PRINT "Jared fell in! AHHH! He is dead now."
DO: LOOP WHILE INKEY$ = ""
END
ELSEIF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = GrassWithSub THEN
IF GotSub <> 1 THEN
LOCATE 1, 1
PRINT "Jared got the Subway! Take it back now!"
PUT (X, Y), Temp, PSET
PUT (SubX, SubY), TheSub
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
GotSub = 1
END IF
ELSEIF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = GrassReturn THEN
IF GotSub = 1 THEN
LOCATE 1, 1: PRINT "Way to go Jared! Lookin' Buff! "
IF CurrentLevel <> NumberOfLevels THEN
JaredInitVariables
CurrentLevel = CurrentLevel + 1
JaredDrawLevel
ELSE
END
END IF
END IF
ELSEIF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) <> Nothing THEN
Falling = 0
InAir = 0
Count = 0
ELSEIF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = Nothing AND InAir = 0 THEN
Falling = 1
END IF
END SUB

SUB JaredDrawLevel
c = CurrentLevel

FOR a = 1 TO HeightOfMap
FOR B = 1 TO LengthOfMap
READ TheTile
AreaMap(B, a, c) = TheTile
PSET (1, 1), 0
PUT STEP(B * LengthOfTile, a * HeightOfTile), Graphics(Associate(TheTile)), PSET
NEXT
NEXT

GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR

PUT (SubX, SubY), TheSub, PSET
END SUB

SUB JaredGetGraphics

FOR c = 1 TO NumberOfTiles
FOR a = 1 TO HeightOfTile
FOR B = 1 TO LengthOfTile
READ Colour
PSET (B, a), Colour
NEXT
NEXT
GET (1, 1)-(LengthOfTile, HeightOfTile), Graphics(Associate(c))
NEXT

FOR c = 1 TO NumberOfGuys
FOR a = 1 TO HeightOfTile * 2
FOR B = 1 TO LengthOfTile
READ Colour
PSET (B, a), Colour
NEXT
NEXT
GET (1, 1)-(LengthOfTile, HeightOfTile * 2), YourGuy(AssociateYou(c))
FOR d = 1 TO HeightOfTile * 2
FOR e = 1 TO LengthOfTile
IF POINT(e, d) = 0 THEN
PSET (e, d), 255
ELSE
PSET (e, d), 0
END IF
NEXT
NEXT
GET (1, 1)-(LengthOfTile, HeightOfTile * 2), YourGuyMask(AssociateYou(c))
NEXT

FOR a = 1 TO HeightOfTile
FOR B = 1 TO LengthOfTile
READ Colour
PSET (B, a), Colour
NEXT
NEXT
GET (1, 1)-(LengthOfTile, HeightOfTile), TheSub

CLS
END SUB

SUB JaredInitVariables
Falling = 0
GotSub = 0
InAir = 0
AssociateX = 1
AssociateY = 8
SubX = LengthOfTile * LengthOfMap
SubY = GroundLevel
X = LengthOfTile
Y = GroundLevel - HeightOfTile
CurrentDirection = 1

Count = 0
FOR a = 1 TO UBOUND(Graphics) STEP SizeOfImage
Count = Count + 1
Associate(Count) = a
NEXT

Count = 0
FOR a = 1 TO UBOUND(YourGuy) STEP SizeOfImage * 2
Count = Count + 1
AssociateYou(Count) = a
NEXT
END SUB

SUB JaredIntro
CLS
LOCATE 1, 5: PRINT "Jared and the Subway Adventure"
DO: LOOP WHILE INKEY$ = ""
LOCATE 2, 10: PRINT "By: Blurred Visions"
DO: LOOP WHILE INKEY$ = ""
CLS
END SUB

SUB JaredMainLoop
DO
JaredCheckDeath
IF InAir THEN Count = Count + 1
SELECT CASE INKEY$
CASE CHR$(0) + "M"
IF AssociateX <> LengthOfMap THEN
IF AreaMap(AssociateX + 1, AssociateY, CurrentLevel) <> Grass THEN
PUT (X, Y), Temp, PSET
IF CurrentDirection = 1 THEN
X = X + OneStep
AssociateX = AssociateX + 1
ELSE
CurrentDirection = 1
END IF
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
END IF
END IF
CASE CHR$(0) + "K"
IF AssociateX <> 1 THEN
IF AreaMap(AssociateX - 1, AssociateY, CurrentLevel) <> Grass THEN
PUT (X, Y), Temp, PSET
IF CurrentDirection = 2 THEN
X = X - OneStep
AssociateX = AssociateX - 1
ELSE
CurrentDirection = 2
END IF
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
END IF
END IF
CASE CHR$(0) + "H"
IF InAir <> 1 THEN
IF AreaMap(AssociateX, AssociateY, CurrentLevel) = Ladder THEN
PUT (X, Y), Temp, PSET
AssociateY = AssociateY - 1
Y = Y - OneStep
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
ELSEIF AreaMap(AssociateX, AssociateY, CurrentLevel) <> Ladder THEN
PUT (X, Y), Temp, PSET
Y = Y - OneStep
InAir = 1
AssociateY = AssociateY - 1
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
EXIT DO
END IF
END IF
CASE CHR$(0) + "P"
IF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = Ladder THEN
PUT (X, Y), Temp, PSET
AssociateY = AssociateY + 1
Y = Y + OneStep
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
END IF
CASE CHR$(32)
LOCATE 1, 1: PRINT " "
LOCATE 1, 1: PRINT AssociateX; AssociateY; Count; InAir; Falling; AreaMap(AssociateX, AssociateY + 1, CurrentLevel)
CASE CHR$(27)
END
END SELECT

IF Falling THEN
Count = Count + 1
IF Count = 3000 THEN
Count = 0
Falling = 0
Start = AssociateY
PUT (X, Y), Temp, PSET
FOR a = Start TO HeightOfMap
IF AreaMap(AssociateX, a + 1, CurrentLevel) <> Nothing THEN
EXIT FOR
END IF
Y = Y + OneStep
AssociateY = AssociateY + 1
NEXT
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
END IF
END IF

IF InAir THEN
IF Count = 11000 THEN
PUT (X, Y), Temp, PSET
InAir = 0
Count = 0
Flag = 0
DO
IF AreaMap(AssociateX, AssociateY + 1, CurrentLevel) = Nothing THEN
Y = Y + OneStep
AssociateY = AssociateY + 1
Flag = 0
ELSE
EXIT DO
END IF
LOOP UNTIL Flag
GET (X, Y)-STEP(LengthOfTile, HeightOfTile * 2), Temp
PUT (X, Y), YourGuyMask(AssociateYou(CurrentDirection)), AND
PUT (X, Y), YourGuy(AssociateYou(CurrentDirection)), OR
EXIT DO
END IF
END IF
LOOP
END SUB

